{% extends 'layout.html' %}
{% load static %}

{% block title %}Article{% endblock %}

{% block body %}

	{% include 'navbar.html' %}

	<div id="article" class="white-bg-div">
		<div class="content">
			<h5 class="article-label">WEB DEVELOPMENT</h5>
			<h1 class="article-title">NGINX's Load Balancer</h1>
			<span class="title-divider"></span>
			<p class="paragraph-article">
				Pada umumnya, terdapat beberapa server yang melayani suatu website. <i>Load balancer</i> bertugas untuk mengatur <i>traffic</i> antara <i>request</i> dari <i>browser</i> dan server yang melayani <i>request</i> tersebut. Pengaturan tersebut diperlukan agar tidak terjadi penumpukan <i>request</i> di salah satu server saja, yang berpotensi membuat layanan web menjadi terganggu. Selain itu, <i>load balancer</i> juga berperan untuk memastikan operasi yang tengah berlangsung tidak terganggu jika terjadi gangguan pada server, yaitu dengan cara mengalihkan beban kerjanya ke server lain. Tugas-tugas yang dijalankan oleh <i>load balancer</i> seperti yang telah dijelaskan sebelumnya berfungsi untuk mendukung sifat <i>high availability</i> dari suatu website.
			</p>
			<p class="paragraph-article">
				Cara kerja <i>load balancer</i> adalah melakukan penerimaan <i>request</i> dari <i>browser</i>, kemudian meneruskan <i>request</i> tersebut ke salah satu dari server yang ada. Ketika server sudah mengembalikan konten HTML atau <i>resource</i>yang diminta kepada <i>load balancer</i>, maka konten tersebut akan diteruskan kepada <i>browser</i>. Wujud <i>load balancer</i> bisa dalam bentuk <i>hardware</i> maupun <i>software</i>.<br>Contoh <i>load balancer</i> dalam bentuk <i>hardware</i> : F5 BIG-IP <i>load balancer</i>, CISCO <i>system catalyst</i>, Barracuda <i>load balancer</i>.<br>Contoh <i>load balancer</i> dalam bentuk <i>software</i> : NGINX, HAProxy, Varnish.
			</p>
			<p class="paragraph-article">
				Pada kesempatan kali ini, saya akan mencoba untuk mensimulasikan cara kerja <i>load balancer</i> menggunakan NGINX. Langkah pertama yang perlu dilakukan adalah men-<i>download</i>NGINX. Apabila Anda menggunakan Windows, dapat mengunjungi <a href="http://nginx.org/en/download.html">http://nginx.org/en/download.html</a>. 
			</p>
			<div class="img-container">
				<img class= 'img-article' src="{% static 'story4/images/nginx-download.JPG' %}">
			</div>
			<p class="paragraph-article">
				Untuk percobaan kali ini, saya menggunakan versi 1.14.2. File yang ter-<i>download</i> nantinya akan dalam bentuk zip, silakan ekstrak dan letakkan di direktori yang Anda inginkan. Saya pribadi meletakkannya di C:\Users\ASUS. Buka cmd, lalu arahkan ke direktori tempat penyimpanan NGINX, jalankan perintah berikut:
			</p>
			<div class="img-container">
				<img class= 'img-article' src="{% static 'story4/images/start-nginx.JPG' %}">
			</div>
			<p class="paragraph-article">
				Untuk mengetes apakah NGINX telah ter-<i>install</i> dengan sempurna, buka browser dan isi <i>address bar</i> dengan localhost. Apabila muncul tampilan seperti di bawah ini, maka NGINX telah berhasil ter-<i>install</i>.
			</p>
			<div class="img-container">
				<img class= 'img-article' src="{% static 'story4/images/nginx-default.JPG' %}">
			</div>
			<p class="paragraph-article">
				Langkah selanjutnya adalah melakukan konfigurasi <i>load balancer</i>. Buka file nginx.conf yang terletak di dalam folder conf (dalam kasus saya <i>path</i>-nya adalah C:\Users\ASUS\nginx-1.14.2\conf\nginx.conf). Pada <i>block</i> http, tambahkan konfigurasi seperti di bawah ini:
			</p>
			<div class="img-container">
				<img class= 'img-article' src="{% static 'story4/images/config.JPG' %}">
			</div>
			<p class="paragraph-article">
				Isi <i>block</i> upstream dengan server yang akan digunakan untuk melayani request dari <i>browser</i>. Pastikan pula nama upstream sama dengan proxy_pass. Nyalakan Django App di server-server yang Anda libatkan sebelumnya di file konfigurasi dengan menjalankan perintah runserver di beberapa cmd berbeda. Contohnya sebagai berikut:
			</p>
			<div class="img-container">
				<img class= 'img-article' src="{% static 'story4/images/port-8000.JPG' %}">
			</div>
			<div class="img-container">
				<img class= 'img-article' src="{% static 'story4/images/port-9000.JPG' %}">
			</div>
			<p class="paragraph-article">
				Kemudian <i>reload</i> NGINX dengan menjalankan perintah berikut:
			</p>
			<div class="img-container">
				<img class= 'img-article' src="{% static 'story4/images/reload-nginx.JPG' %}">
			</div>
			<p class="paragraph-article">
				Selanjutnya, buka browser dan isi <i>address bar</i> dengan localhost:8080 (disesuaikan dengan nilai dari listen dan server_name pada file konfigurasi).Tampilkan dan bandingkan beberapa cmd yang sebelumnya digunakan untuk menjalankan perintah runserver sembari melakukan <i>refresh</i> berulang-ulang pada halaman <i>browser</i>.
			</p>
			<p class="paragraph-article">
				Saat <i>load</i> pertama kali:
			</p>
			<div>
				<div class="img-container">
					<img class= 'img-article' src="{% static 'story4/images/load-first.JPG' %}">
				</div>
				<div class="img-container">
					<img class= 'img-article' src="{% static 'story4/images/port-9000.JPG' %}">
				</div>
			</div>
			<p class="paragraph-article">
				Saat <i>load</i> kedua kali:
			</p>
			<div>
				<div class="img-container">
					<img class= 'img-article' src="{% static 'story4/images/load-first.JPG' %}">
				</div>
				<div class="img-container">
					<img class= 'img-article'  class= 'img-article'src="{% static 'story4/images/load-second.JPG' %}">
				</div>
			</div>
			<p class="paragraph-article">
				Saat <i>load</i> ketiga kali:
			</p>
			<div>
				<div class="img-container">
					<img class= 'img-article' src="{% static 'story4/images/load-third.JPG' %}">
				</div>
				<div class="img-container">
					<img class= 'img-article' src="{% static 'story4/images/load-second.JPG' %}">
				</div>
			</div>
			<p class="paragraph-article">
				Saat <i>load</i> keempat kali:
			</p>
			<div>
				<div class="img-container">
					<img class= 'img-article' src="{% static 'story4/images/load-third.JPG' %}">
				</div>
				<div class="img-container">
					<img class= 'img-article' src="{% static 'story4/images/load-fourth.JPG' %}">
				</div>
			</div>
			<p class="paragraph-article">
				Perhatikan bahwa server-server tersebut melayani <i>request</i> dari <i>browser</i> secara bergantian. Apabila kita mematikan salah satu server (misal pada port 9000, dapat dilakukan dengan menekan <b>Ctrl+C</b> pada cmd), <i>request</i> dari <i>browser</i> tetap akan diproses dan dilayani oleh server lainnya yang masih aktif.
			</p>
			<p class="paragraph-article">
				Saat <i>load</i> kelima kali:
			</p>
			<div class="img-container">
				<img class= 'img-article' src="{% static 'story4/images/load-fifth.JPG' %}">
			</div>
			<p class="paragraph-article">
				Saat <i>load</i> keenam kali:
			</p>
			<div class="img-container">
				<img class= 'img-article' src="{% static 'story4/images/load-sixth.JPG' %}">
			</div>
			<p class="paragraph-article">
				Sekian penjelasan mengenai <i>load balancer</i> menggunakan NGINX, semoga bermanfaat!
			</p>
		</div>
	</div>

	{% include 'contact.html' %}
		
{% endblock %}